package com.jasamedika.medifirst2000.dao.custom.impl;

import java.util.List;
import java.util.Map;

import javax.persistence.Query;

import org.springframework.stereotype.Repository;

import com.jasamedika.medifirst2000.dao.custom.PemeriksaanLimbahDaoCustom;
import com.jasamedika.medifirst2000.dao.custom.base.impl.CoreDaoImpl;
import com.jasamedika.medifirst2000.entities.PemeriksaanLimbah;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.util.DateUtil;

/**
 * Repository Custom class
 * 
 * @author Roberto
 */
@Repository
public class PemeriksaanLimbahDaoCustomImpl extends CoreDaoImpl<PemeriksaanLimbah> implements
		PemeriksaanLimbahDaoCustom {

	public PemeriksaanLimbahDaoCustomImpl() {
		super(PemeriksaanLimbah.class);
	}

	@Override
	public List<Map<String, Object>> findListPemeriksaanLimbah(int rowStart, int rowEnd, String sort, String dir,String tanggalAwal, String tanggalAhir, Integer jenisPemeriksaanId) {

		StringBuffer buffer = new StringBuffer();
		buffer.append("select NEW Map ( ");
		buffer.append(" b.name as jenisPemeriksaan, ");
		buffer.append(" a.tanggalPemeriksaan as tanggalPemeriksaan ) ");
		buffer.append("from PemeriksaanLimbah a ");
		buffer.append("left join a.jenisPemeriksaan b where a.noRec is not null  ");
		
		if(CommonUtil.isNotNullOrEmpty(tanggalAwal) && CommonUtil.isNotNullOrEmpty(tanggalAhir)){
			buffer.append("and date(a.tanggalPemeriksaan) between  :tanggalAwal and :tanggalAhir ");
		}
		
		if(CommonUtil.isNotNullOrEmpty(jenisPemeriksaanId)){
			buffer.append(" and a.jenisPemeriksaanId=:jenisPemeriksaanId ");
		}
		
		
		if (sort != "") {
			buffer.append("order by a." + sort + " " + dir);
		} else {
			buffer.append("order by a.noRec desc ");
		}
		Query query = em.createQuery(buffer.toString());
		if(CommonUtil.isNotNullOrEmpty(tanggalAwal) && CommonUtil.isNotNullOrEmpty(tanggalAhir)){
			query.setParameter("tanggalAwal",DateUtil.toDate(tanggalAwal));
			query.setParameter("tanggalAhir", DateUtil.toDate(tanggalAhir));
		}
		
		if(CommonUtil.isNotNullOrEmpty(jenisPemeriksaanId)){
			query.setParameter("jenisPemeriksaanId", jenisPemeriksaanId);
		}
		
		query.setFirstResult(rowStart);
		query.setMaxResults(rowEnd);
		List<Map<String,Object>> list = query.getResultList();

		return list;
	
	}

	@Override
	public Integer findCountPemeriksaanLimbah(String tanggalAwal, String tanggalAhir, Integer jenisPemeriksaanId) {

		StringBuffer buffer = new StringBuffer();
		buffer.append("select count(a) ");
		buffer.append("from PemeriksaanLimbah a ");
		buffer.append("left join a.jenisPemeriksaan b where a.noRec is not null  ");
		
		if(CommonUtil.isNotNullOrEmpty(tanggalAwal) && CommonUtil.isNotNullOrEmpty(tanggalAhir)){
			buffer.append("and date(a.tanggalPemeriksaan) between  :tanggalAwal and :tanggalAhir ");
		}
		
		if(CommonUtil.isNotNullOrEmpty(jenisPemeriksaanId)){
			buffer.append(" and a.jenisPemeriksaanId=:jenisPemeriksaanId ");
		}
		
		Query query = em.createQuery(buffer.toString());
		if(CommonUtil.isNotNullOrEmpty(tanggalAwal) && CommonUtil.isNotNullOrEmpty(tanggalAhir)){
			query.setParameter("tanggalAwal",DateUtil.toDate(tanggalAwal));
			query.setParameter("tanggalAhir", DateUtil.toDate(tanggalAhir));
		}
		if(CommonUtil.isNotNullOrEmpty(jenisPemeriksaanId)){
			query.setParameter("jenisPemeriksaanId", jenisPemeriksaanId);
		}

		return ((Long) query.getSingleResult()).intValue();
	
	}

	

	
}
